<?php

/*
 +-----------------------------------------------------------------------+
 | program/steps/settings/passwd.inc                                     |
 |                                                                       |
 | This file is part of the RoundCube Webmail client                     |
 | Copyright (C) 2007, RoundCube Dev. - Switzerland                      |
 | Licensed under the GNU GPL                                            |
 |                                                                       |
 | PURPOSE:                                                              |
 |   Change IMAP user password                                           |
 |                                                                       |
 | TESTED:                                                               |
 | IMAP account store in database(mysql,postgresql)                      |
 | cPanel [10.9.0-RELEASE_57] (pro)                                      |
 | cPanel Pro   1.0 (RC36)                                               |
 +-----------------------------------------------------------------------+
 | Author: Mo Nianliang <roc.ddk@+++@gmail.+++.com>                      |
 +-----------------------------------------------------------------------+
 $Id: passwd.inc, v0.5 2007-07-06 10:37:23 roundcube Exp $
*/


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Special procedure to change password (e.g. cpanel, db, etc.),
// and you can define a new procedure for yourself.

function change_pwd_for_cpanel($curpasswd, $newpasswd)
{
    global $_SESSION;

    // Define successful respond from cPanel
    $success = "Changed password";

    // Prepare ...
    $curuser = $_SESSION['username'];
    $authstr = "$curuser:$curpasswd";
    $authstr = base64_encode($authstr);
    $request_str = "GET /dowebmailpasswd.cgi?oldpass=$curpasswd&newpass=$newpasswd&B1="
                ."Change+Password HTTP/1.0\r\nAuthorization: Basic $authstr \r\n\r\n";

    // Send request
    $socket = fsockopen("localhost", 2095);
    socket_set_timeout($socket, 30);
    fputs($socket, $request_str);
    $resp = "";
    while (!feof($socket)) {
        $resp .= htmlspecialchars(fgets($socket, 128));
    }
    fclose( $socket );

    // Check respond and return.
    return (false !== strpos($resp, $success));
}

function change_pwd_for_db($curpasswd, $newpasswd)
{
    global $CONFIG, $_SESSION;

    // add md5 crypt, thanks to Diego
    $sqlset = "?";
    if('MD5CRYPT' == $CONFIG['db_imap_passwd_type']){
        $newpasswd = crypt($newpasswd);
    }else{
        $sqlset = $CONFIG['db_imap_passwd_type'] . "(?)";
    }

    $sqlset = "UPDATE " . $CONFIG['db_imap_users_table'] . " SET " . $CONFIG['db_imap_passwd_field'] . " = " . $sqlset .
        " WHERE " . $CONFIG['db_imap_user_field'] . "=? OR ("  . $CONFIG['db_imap_user_field'] . "=? AND domain_name = '')";

    $IMAPDB = new rcube_db($CONFIG['db_imap_dsn'], '', FALSE);
    $IMAPDB->db_connect('w');
    $IMAPDB->query($sqlset, $newpasswd, $_SESSION['username'], $_SESSION['username']);

    return ($IMAPDB->affected_rows() && ($IMAPDB->affected_rows() > 0));
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Generally, you may not change the code below.

function rcmail_save_passwd($curpasswd, $newpasswd)
{
    global $CONFIG, $_SESSION;

    if (! $CONFIG['change_pwd_proc']){
        return false;
    }
    $run_change_pwd = $CONFIG['change_pwd_proc'];

    // Dispatch command and get the result.
    $is_ok = $run_change_pwd($curpasswd, $newpasswd);

    if ($is_ok) {
        $_SESSION['password'] = encrypt_passwd($newpasswd);
    }

    return $is_ok;
}

function rcmail_passwd_form($attrib)
{
    global $CONFIG, $JS_OBJECT_NAME;

    list($form_start, $form_end) = get_form_tags($attrib, 'save-passwd');
    unset($attrib['form']);

    if (!$attrib['id'])
        $attrib['id'] = 'rcmSavepassword';

    // allow the following attributes to be added to the <table> tag
    $attrib_str = create_attrib_string($attrib, array('style', 'class', 'id', 'cellpadding', 'cellspacing', 'border', 'summary'));

    // return the complete edit form as table
    $out = "$form_start<table" . $attrib_str . ">\n\n";

    $a_show_cols = array('curpasswd'   => array('type' => 'text'),
                'newpasswd'   => array('type' => 'text'),
                'confpasswd'   => array('type' => 'text'));

    // show current password selection
    $field_id = 'curpasswd';
    $input_newpasswd = new passwordfield(array('name' => '_curpasswd', 'id' => $field_id, 'size' => 30));

    $out .= sprintf("<tr><td class=\"title\"><label for=\"%s\">%s</label></td><td>%s</td></tr>\n",
                $field_id,
                rep_specialchars_output(rcube_label('curpasswd')),
                $input_newpasswd->show($CONFIG['curpasswd']));

    // show new password selection
    $field_id = 'newpasswd';
    $input_newpasswd = new passwordfield(array('name' => '_newpasswd', 'id' => $field_id, 'size' => 30));

    $out .= sprintf("<tr><td class=\"title\"><label for=\"%s\">%s</label></td><td>%s</td></tr>\n",
                $field_id,
                rep_specialchars_output(rcube_label('newpasswd')),
                $input_newpasswd->show($CONFIG['newpasswd']));

    // show confirm password selection
    $field_id = 'confpasswd';
    $input_confpasswd = new passwordfield(array('name' => '_confpasswd', 'id' => $field_id, 'size' => 30));

    $out .= sprintf("<tr><td class=\"title\"><label for=\"%s\">%s</label></td><td>%s</td></tr>\n",
                $field_id,
                rep_specialchars_output(rcube_label('confpasswd')),
                $input_confpasswd->show($CONFIG['confpasswd']));

    $out .= "\n</table>$form_end";
    return $out;
}

// Handle user request
if ($_action=='save-passwd')
{
    global $_SESSION;

    if (! ( isset($_POST['_curpasswd']) and isset($_POST['_newpasswd'])))
        $OUTPUT->show_message('nopassword', 'error');
    else {
        $curpwd = get_input_value('_curpasswd', RCUBE_INPUT_POST);
        $newpwd = get_input_value('_newpasswd', RCUBE_INPUT_POST);
        if ($_SESSION['password'] != encrypt_passwd($curpwd))
            $OUTPUT->show_message('passwordincorrectly', 'error');
        else if (rcmail_save_passwd($curpwd, $newpwd))
            $OUTPUT->show_message('successfullysaved', 'confirmation');
        else
            $OUTPUT->show_message('errorsaving', 'error');
    }

    // go to next step
    rcmail_overwrite_action('passwd');
}

// add some labels to client
rcube_add_label('nopassword');
rcube_add_label('passwordinconsistency');

parse_template('passwd');
?>
